// siehe http://www.kleine-onlinespiele.de/Balken/balken.htm

public class UE7Aufgabe47 {

	public static void main(String[] args) {
		String dateiname = "Balken1.bb";
		char[][] spielbrett = IO.readFileAsCharMatrix(dateiname);
		print(spielbrett);

		do {
			char balken = balkenWaehlen(spielbrett);
			char richtung = richtungWaehlen(spielbrett);
			balkenVerschieben(balken, richtung, spielbrett);
			ballFallenLassen(spielbrett);
			print(spielbrett);
		} while (!spielEnde(spielbrett));
		System.out.println("Hurra! Geschafft!");

	}

	static void print(char[][] matrix) {
		for (int r = 0; r < matrix.length; r++) {
			for (int s = 0; s < matrix[r].length; s++) {
				System.out.print(matrix[r][s]);
			}
			System.out.println();
		}
		System.out.println();
	}

	static char balkenWaehlen(char[][] brett) {
		char nummer = IO.readChar("Balken whlen: ");
		while (!vorhanden(brett, nummer)) {
			nummer = IO.readChar("Fehlerhafte Eingabe! Balken whlen: ");
		}
		return nummer;
	}

	static boolean vorhanden(char[][] matrix, char zeichen) {
		for (int r = 0; r < matrix.length; r++) {
			for (int s = 0; s < matrix[r].length; s++) {
				if (matrix[r][s] == zeichen) {
					return true;
				}
			}
		}
		return false;
	}

	static char richtungWaehlen(char[][] brett) {
		char richtung = IO.readChar("Richtung whlen (l=links, r=rechts): ");
		while (!(richtung == 'l' || richtung == 'r')) {
			richtung = IO
					.readChar("Fehlerhafte Eingabe! Richtung whlen (l=links, r=rechts): ");
		}
		return richtung;
	}

	static void balkenVerschieben(char balken, char richtung, char[][] brett) {
		if (richtung == 'l') {
			for (int r = 0; r < brett.length; r++) {
				for (int s = 0; s < brett[r].length; s++) {
					if (brett[r][s] == balken) {
						if (s == 0) {
							return; // verschieben nicht moeglich
						} else {
							if (brett[r][s - 1] == '*') { // Ball verschieben?
								if (s - 1 == 0) { // Ball am Rand
									return; // verschieben nicht moeglich
								} else {
									brett[r][s - 2] = '*';
									brett[r][s - 1] = ' ';
								}
							}
							brett[r][s - 1] = balken;
							brett[r][s] = ' ';
						}
					}
				}
			}
		} else { // richtung == 'r'
			for (int r = 0; r < brett.length; r++) {
				for (int s = brett[r].length - 1; s >= 0; s--) {
					if (brett[r][s] == balken) {
						if (s == brett[r].length - 1) {
							return; // verschieben nicht moeglich
						} else {
							if (brett[r][s + 1] == '*') { // Ball verschieben?
								if (s + 1 == brett[r].length - 1) { // Ball am
																	// Rand
									return; // verschieben nicht moeglich
								} else {
									brett[r][s + 2] = '*';
									brett[r][s + 1] = ' ';
								}
							}
							brett[r][s + 1] = balken;
							brett[r][s] = ' ';
						}
					}
				}
			}
		}
	}

	static void ballFallenLassen(char[][] brett) {
		for (int r = 0; r < brett.length; r++) {
			for (int s = brett[r].length - 1; s >= 0; s--) {
				if (brett[r][s] == '*') {
					fallen(brett, r, s);
					return;
				}
			}
		}
	}

	static void fallen(char[][] brett, int reihe, int spalte) {
		for (int r = reihe + 1; r < brett.length; r++) {
			if ('0' <= brett[r][spalte] && brett[r][spalte] <= '9'
					|| brett[r][spalte] == '+') {
				// Balken oder Grund vorhanden
				return;
			} else {
				// eine Reihe runter
				brett[r][spalte] = '*';
				brett[r - 1][spalte] = ' ';
			}
		}
	}

	static boolean spielEnde(char[][] brett) {
		for (int s = 0; s < brett[brett.length - 1].length - 1; s++) {
			if (brett[brett.length - 1][s] == '*') {
				return true;
			}
		}
		return false;
	}

}
