public class UE7Aufgabe51 {

	static final int START_KAPITAL = 10; // Bonbons fr jeden Spieler
	static final int ANZAHL_SPIELER = 5; // Anzahl an Spielern

	// Hauptprogramm
	public static void main(String[] args) {
		// Initialisierung
		int[] spieler = new int[ANZAHL_SPIELER]; // Bonbons jedes Spielers
		for (int i = 0; i < spieler.length; i++) {
			spieler[i] = START_KAPITAL;
		}

		// Spieldurchfhrung
		int aktSpieler = 0; // Index des aktuellen Spielers
		int kasse = 0; // Bonbons in der Kasse
		while (!spielende(spieler)) {
			int dreidel = 1 + (int) (Math.random() * 4); // wuerfeln
			kasse = spielzug(spieler, aktSpieler, kasse, dreidel);
			ausgeben(spieler, aktSpieler, dreidel, kasse);
			aktSpieler = naechsterSpieler(spieler, aktSpieler);
		}
	}

	// Ausgabe von aktuellen Spielinformationen
	private static void ausgeben(int[] spieler, int aktSpieler, int dreidel,
			int kasse) {
		System.out.println("Spielstand: ");
		System.out.println("Gewuerfelt: " + dreidel);
		System.out.println("Aktueller Spieler = Spieler " + aktSpieler);
		for (int i = 0; i < spieler.length; i++) {
			System.out.println("Spieler " + i + ": " + spieler[i] + " Bonbons");
		}
		System.out.println("Kassenstand: " + kasse + " Bonbons");
		IO.readChar("<RETURN> drcken");

	}

	/**
	 * Ueberprueft das Spielende
	 * 
	 * @param spieler
	 *            die Anzahl an Bonbons der einzelnen Spieler
	 * @return genau dann true, wenn kein oder nur noch ein Spieler Bonbons
	 *         besitzt
	 */
	static boolean spielende(int[] spieler) {
		int pleite = 0;
		for (int i = 0; i < spieler.length; i++) {
			if (spieler[i] == 0) {
				pleite++;
			}
		}
		return pleite >= ANZAHL_SPIELER - 1;
	}

	/**
	 * ermittelt den naechsten Spieler gemaess folgender Regeln: (1) es wird
	 * reihum gezogen (2) Spieler ohne Bonbons sind bereits ausgeschieden
	 * 
	 * @param spieler
	 *            Anzahl an Bonbons der einzelnen Spieler
	 * @param aktSpieler
	 *            Array-Index des Spielers, der zuletzt an der Reihe war
	 * @return Array-Index des Spielers, der als naechster an der Reihe ist
	 */
	static int naechsterSpieler(int[] spieler, int aktSpieler) {
		while (true) {
			aktSpieler = (aktSpieler + 1) % ANZAHL_SPIELER;
			if (spieler[aktSpieler] > 0) {
				return aktSpieler;
			}
		}
	}

	/**
	 * fuehrt einen Spielzug gemaess der Dreidel-Spielregeln aus
	 * 
	 * @param spieler
	 *            Anzahl an Bonbons der einzelnen Spieler
	 * @param aktSpieler
	 *            Array-Index des Spielers, der an der Reihe ist
	 * @param kasse
	 *            Anzahl an Bonbons in der Kasse (vor dem Spielzug)
	 * @param dreidel
	 *            der gewuerfelte Dreidel-Wert
	 * @return Anzahl an Bonbons in der Kasse (nach dem Spielzug)
	 */
	static int spielzug(int[] spieler, int aktSpieler, int kasse, int dreidel) {
		switch (dreidel) {
		case 1: // nichts
			break;
		case 2:
			spieler[aktSpieler] += kasse;
			kasse = 0;
			for (int i = 0; i < spieler.length; i++) {
				if (spieler[i] > 0) {
					kasse++;
					spieler[i]--;
				}
			}
			break;
		case 3:
			spieler[aktSpieler] += kasse / 2;
			kasse -= kasse / 2;
			break;
		case 4:
			spieler[aktSpieler]--;
			kasse++;
		}
		return kasse;
	}

}
