// http://projecteuler.net/problem=344
public class UE7Aufgabe59 {

	public static void main(String[] args) {
		char[] brett = { '.', '1', '.', '.', '1', '.', '1', '2', '.', '1' };

		int spieler = 1;
		System.out.println(brett);
		while (true) {
			System.out.println("Spieler " + spieler + " ist am Zug!");
			char typ = getSpielzugTyp();
			if (typ == 'R') { // Regulaerer Spielzug

				// Spielzug einlesen
				int vonIndex = IO.readInt("Von Feldindex?");
				int nachIndex = IO.readInt("Nach Feldindex?");

				// Spielzug ueberpruefen
				if (!rSpielzugOk(brett, vonIndex, nachIndex)) {
					System.out.println("Ungueltiger Spielzug! Spieler "
							+ spieler + " hat verloren!");
					return;
				}

				// Spielzug ausfuehren
				brett[nachIndex] = brett[vonIndex];
				brett[vonIndex] = '.';
			} else { // Spezieller Spielzug
				// Spielzug berechnen
				int vonIndex = berechneSSpielzugIndex(brett);

				// Spielzug ausfuehren
				brett[vonIndex] = '.';
			}
			System.out.println(brett);

			// Spielende ueberpruefen
			if (spielende(brett)) {
				System.out.println("Spielende! Spieler " + spieler
						+ " hat gewonnen!");
				return;
			}

			// Spielerwechsel
			spieler = spieler % 2 + 1;
		}
	}

	static char getSpielzugTyp() {
		char typ = IO.readChar("R- oder S-Spielzug? (R/S)");
		while (typ != 'R' && typ != 'S') {
			typ = IO.readChar("Fehlerhafte Eingabe! R- oder S-Spielzug? (R/S)");
		}
		return typ;
	}

	private static boolean spielende(char[] brett) {
		for (char ch : brett) {
			if (ch == '2') {
				return false;
			}
		}
		return true;
	}

	private static int berechneSSpielzugIndex(char[] brett) {
		for (int i = 0; i < brett.length; i++) {
			if (brett[i] != '.') {
				return i;
			}
		}
		return -1; // nicht moeglich
	}

	private static boolean rSpielzugOk(char[] brett, int vonIndex,
			int nachIndex) {
		if (vonIndex < 0 || nachIndex < 0 || vonIndex >= brett.length
				|| nachIndex >= brett.length) {
			return false;
		}
		if (nachIndex >= vonIndex) {
			return false;
		}
		for (int i = vonIndex - 1; i >= nachIndex; i--) {
			if (brett[i] != '.') {
				return false;
			}
		}
		return true;
	}

}
